//
// This file is part of an OMNeT++/OMNEST simulation example.
//
// Contributed by Nick van Foreest
//
// This file is distributed WITHOUT ANY WARRANTY. See the file
// `license' for details on this and other legal matters.
//

#include "gen.h"


Define_Module( Generator );

void Generator::activity()
{
    cMessage *zadanie_odebrane;
	cPar& ia_time = par("ia_time");
    cPar& hit_size = par("hit_size");
    int liczba_zadan = par("requests");
    czas_przebywania.setName("czas przebywania");
	

    for (int i=0; i<liczba_zadan; i++)
    {
		char nazwa[15];
		//sprintf(nazwa, "zadanie %d", i);
    
		cMessage *zadanie = new cMessage(nazwa);
		zadanie->setLength(hit_size);
		zadanie->setKind(1);


		send(zadanie, "do_fifo");

		waitAndEnqueue((double) ia_time, &kolejka);	
        
	
		while( ! kolejka.empty() )
		{
			zadanie_odebrane = (cMessage *)kolejka.pop();

		    czas_przebywania.record( (zadanie_odebrane->arrivalTime() - zadanie_odebrane->creationTime()) ); 

			delete zadanie_odebrane;
		}
    }
}

